Bug 1733685 (python-pydantic) - Review Request: python-pydantic - Data validation using Python type hinting
Summary: Review Request: python-pydantic - Data validation using Python type hinting
Keywords:
Status: POST
Alias: python-pydantic
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1787448 (view as bug list)
Depends On: python-email_validator 1787419
Blocks: python-qcelemental 1733680 python-pytest-toolbox
TreeView+ depends on / blocked
 
Reported: 2019-07-27 10:04 UTC by Susi Lehtola
Modified: 2020-01-07 16:23 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Susi Lehtola 2019-07-27 10:04:12 UTC
Spec URL: https://jussilehtola.fedorapeople.org/python-pydantic.spec
SRPM URL: https://jussilehtola.fedorapeople.org/python-pydantic-0.31-1.fc30.src.rpm
Fedora Account System Username: jussilehtola

Description:
Data validation and settings management using python type hinting.

Comment 1 Robert-André Mauchin 2019-07-27 16:13:12 UTC
 - There are docs, build them with Sphinx

 - There are tests, run them in %check


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License". 138 files have unknown
     license. Detailed output of licensecheck in
     /home/bob/packaging/review/python-pydantic/review-python-
     pydantic/licensecheck.txt
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-pydantic-0.31-1.fc31.noarch.rpm
          python-pydantic-0.31-1.fc31.src.rpm
python3-pydantic.noarch: E: zero-length /usr/lib/python3.7/site-packages/pydantic/py.typed
2 packages and 0 specfiles checked; 1 errors, 0 warnings.

Comment 2 Fabian Affolter 2020-01-06 20:19:02 UTC
Susi, are you planning to go on with this review?

Comment 3 Susi Lehtola 2020-01-06 20:41:11 UTC
Fabian, yes! My apologies for missing your extremely quick review.

Comment 4 Susi Lehtola 2020-01-06 21:06:39 UTC
New spec and srpm at
https://jussilehtola.fedorapeople.org/python-pydantic.spec
https://jussilehtola.fedorapeople.org/python-pydantic-1.3-1.fc31.src.rpm

Updating to the newest release, the docs have moved to mkdocs
 https://github.com/samuelcolvin/pydantic/pull/856
but mkdocs isn't available on Fedora. I've included the Markdown documentation for now, and noted this in the spec file.

I've also added the check phase.

Comment 5 Robert-André Mauchin 2020-01-06 23:01:37 UTC
DEBUG util.py:582:  Error: 
DEBUG util.py:582:   Problem: cannot install the best candidate for the job
DEBUG util.py:582:    - nothing provides python3.8dist(mypy-extensions) >= 0.4.3 needed by python3-mypy-0.761-1.fc32.noarch

I'll bother Igor or do the update myself tomorrow.

Comment 6 Robert-André Mauchin 2020-01-07 00:26:59 UTC
- You need to add pytest to the BR to run the tests:

# For check
BuildRequires:  python3dist(pytest)



 - License ok
 - Latest version packaged
 - Builds in mock
 - No rpmlint errors
 - Conforms to Packaging Guidelines

Package approved. Fix the aforementioned issue before import.

Comment 7 Susi Lehtola 2020-01-07 09:37:49 UTC
pytest dependence added. Thanks again for the review!

https://jussilehtola.fedorapeople.org/python-pydantic.spec
https://jussilehtola.fedorapeople.org/python-pydantic-1.3-2.fc31.src.rpm

Comment 8 Fabian Affolter 2020-01-07 16:23:45 UTC
*** Bug 1787448 has been marked as a duplicate of this bug. ***


Note You need to log in before you can comment on or make changes to this bug.